#*****************************************************
# RPM Wizard
# Copyright 2002 Magnus Bjorklof <bjorklof@nic.fi>
# License: GNU General Public License
#*****************************************************

import os
import fnmatch
import sys
import string
import commands
from rpmwizdbcreator import DBCreator
from conf import *

from qt import QFileInfo


def searchDepSatisfier(dep, databases):
    """Search for files that can satisfy the dependencies."""
    print "searchDepSatisfier"
    neededFiles=[]

    cdrom=0
    try:
    	(dirFiles, dirDepends, dirProvides)=databases # dirDepends is not used here
    except:
	cdrom=1
	pass


    filelist=[]
    try:
    	filelist=os.listdir(DATABASEDIR)
    except OSError:
    	print "Could not find database"

    rpmdatabaselist=[]
    for f in filelist:
	if fnmatch.fnmatch(f, 'list.*')==1:
		rpmdatabaselist.append(f)

    provides_files=commands.getoutput('ls '+DATABASEDIR+'/provides*') #why do I have two different ways to handle the same thing??
    provides_files=string.split(provides_files, '\n')


    provideslist=[]
    for fil in provides_files:
    	try:
    		fd2=open(fil)
    		provideslist=provideslist+fd2.readlines()
    		fd2.close()
    	except:
		print "could not open provides file"


    if cdrom==0:
	dirProvidesList=string.split(dirProvides, '\n')
    	provideslist=dirProvidesList+provideslist



    dep2=[]

    for p in provideslist:

	plist=string.split(p, '@')
	
	if plist==['']:
		continue

	# to make this quicker it should (maybe) stop when it has found all


	for d in dep:
	    if compareStrings(string.strip(d), plist[0])==1:
		neededFiles.append((string.strip(plist[1]), d)) 


    if neededFiles==[]:
    	return []
    list=[]
   

    rpmfilestuple=[]
    for dbfile in rpmdatabaselist:
	try:
		fd=open(DATABASEDIR+'/'+dbfile)
		rpmfileslist=fd.readlines()
		fd.close()
	except:
		print "Could not open", dbfile
		continue
	
	for filerow in rpmfileslist:
		rpmfilestuple.append((filerow, dbfile[5:]))



    if cdrom==0:
	dirFilesList=string.split(dirFiles, '\n')
	for filerow in dirFilesList:
		rpmfilestuple.append((filerow, ''))

    for (row,sname) in rpmfilestuple:
		r=string.split(row, ':/')

		for (neededfile, dep) in neededFiles:

		    if len(r)<2:
		    	continue


		    if fnmatch.fnmatch(r[1], '*'+neededfile+'*')==1:
				for d in list: # try to ensure that two different files that provide the
				    # same thing are not added

				    if d[1]==dep:
				    	# we prefere 'file' over 'removable' (and the others)
				        if d[3]=='file':
						break
					elif r[0][:9]=="removable":
						break
					elif r[0]=='file':
						list.remove(d)
					else:
						break



				else:
				    list.append(((None,string.strip(r[1])), dep, sname, r[0]))


 
    #return a list with tuples:  ((header, file), dep, storagename, type) header can be None
    print "list",list
    return list


def compareStrings(dep, prov):
	"""Compare the provides and depends string and return 1 if they match otherwise 0"""

	dep2=string.split(dep)
	prov2=string.split(prov)


	if dep2[0]!=prov2[0]:
		return 0
		
	if dep2==prov2:
		return 1

	if len(dep2)==1: # in this case it doesn't require a specific version
		return 1

	if len(prov2)<2 and len(dep2)>1: # this is if provides has no version but dep has; names still match
		print "this should not have happened ..."
		return 1




	prov3=string.split(prov2[2], '-')
	dep3=string.split(dep2[2], '-')

	if dep2[1]=='>=':
		prov=string.split(prov3[0], '.')
		dep=string.split(dep3[0], '.')
		t=0
		for pv in prov:
			if len(dep)<(t+1): # in this case we have e.g. prov=3.5.1 and dep=3.5; we can safely return 1
				return 1
			if pv==dep[t]: #sometimes the items are not integers eg. mod_perl-common = 1.3.23_1.26
				pass

			elif int(pv)>int(dep[t]):
				return 1

			else:
				return 0
			t=t+1

		else:
			return 1
	elif dep2[1]=='=':
		if prov3[0]==dep3[0]:
			return 1
		else:
			return 0

	else:
		print "PANIC", dep
		return 0 





def getDepDatabase(databases):
	"""This function reads the dependency database and returns a list of what the files depend on."""
	print "getDepDatabase"


	cdrom=0
	try:
		(dirFiles, dirDepends, dirProvides)=databases
	except:
		cdrom=1


	try:
    		filelist=os.listdir(DATABASEDIR)
   	except OSError:
    		print "Could not find database"
		filelist=[]


	dependsfiles=[]
	for f in filelist:
		if fnmatch.fnmatch(f, '*depends.*')==1:
			dependsfiles.append(DATABASEDIR+f)

	
	dependslist=[]
    	for fil in dependsfiles:
    	    try:
    		fd2=open(fil)
    		dependslist=dependslist+fd2.readlines()
    		fd2.close()

    	    except:
		print "could not open depends file"

	if cdrom==0:
		dirDependsList=string.split(dirDepends, '\n')
		dependslist=dirDependsList+dependslist
    	

	return dependslist

