#*****************************************************
# RPM Wizard
# Copyright 2001-2002 Magnus Bjorklof <bjorklof@nic.fi>
# License: GNU General Public License
#*****************************************************

from qt import *

import string
import rpm
import test


class DetailsDialog(QDialog):
    def __init__(self,parent = None,name = None,modal = 1,fl = 0):
        QDialog.__init__(self,parent,name,modal,fl)

        if name == None:
            self.setName('MyDialog1')

        self.resize(383,382)

        self.setSizeGripEnabled(1)

        Layout13 = QVBoxLayout(self)
        Layout13.setSpacing(6)
        Layout13.setMargin(11)

        self.tabWidget = QTabWidget(self,'tabWidget')

	self.MultiLineEdit17 = QTextView(self.tabWidget,'MultiLineEdit17')

	self.tabWidget.insertTab(self.MultiLineEdit17,self.tr('Properties'))

        self.ListView2 = QListView(self.tabWidget,'ListView2')

	self.tabWidget.insertTab(self.ListView2,self.tr('Files'))
        Layout13.addWidget(self.tabWidget)

        Layout12 = QHBoxLayout()
        Layout12.setSpacing(6)
        Layout12.setMargin(0)
        spacer = QSpacerItem(20,20,QSizePolicy.Expanding,QSizePolicy.Minimum)
        Layout12.addItem(spacer)

        self.buttonOk = QPushButton(self,'buttonOk')
        self.buttonOk.setText(self.tr('&OK'))
        self.buttonOk.setAutoDefault(1)
        self.buttonOk.setDefault(1)
        Layout12.addWidget(self.buttonOk)
        spacer_2 = QSpacerItem(20,20,QSizePolicy.Expanding,QSizePolicy.Minimum)
        Layout12.addItem(spacer_2)

        Layout13.addLayout(Layout12)

        self.connect(self.buttonOk,SIGNAL('clicked()'),self,SLOT('accept()'))

    def setValues(self, desc, files):

	self.MultiLineEdit17.setText(desc)

	self.ListView2.addColumn(str(len(files))+' files' )

        for f in files:
        	if f==files[0]:

			self.item = QListViewItem(self.ListView2,None)
                        ff=string.strip(f)
			self.item.setText(0, ff)
		else:
			self.item = QListViewItem(self.ListView2,self.item)
                        ff=string.strip(f)
			self.item.setText(0, f)

class GetDetails:
    def __init__(self, header):
    	self.header=header
	
    def get(self):

    	header=self.header

 	files=header[rpm.RPMTAG_FILENAMES]
	name=header[rpm.RPMTAG_NAME]
	summary=header[rpm.RPMTAG_SUMMARY]
	version=header[rpm.RPMTAG_VERSION]
	group=header[rpm.RPMTAG_GROUP]
	size=str(header[rpm.RPMTAG_SIZE])
	distribution=header[rpm.RPMTAG_DISTRIBUTION]
	vendor=header[rpm.RPMTAG_VENDOR]
	packager_=header[rpm.RPMTAG_PACKAGER]
	provides_=header[rpm.RPMTAG_PROVIDES]
	(unsatisfied, conflicts, iii, ooo)=test.depCheck(self, self.header, databases='', details_dialog=1)


	def correct(item):
		item=string.replace(item, '<', '&#60;')
		item=string.replace(item, '>', '&#62;')
		return item

	if packager_!=None:
		packager=correct(packager_)
	else:
		packager=None



	reqflags=header[rpm.RPMTAG_REQUIREFLAGS]
	reqnames=header[rpm.RPMTAG_REQUIRENAME]
	reqversions=header[rpm.RPMTAG_REQUIREVERSION]
	g=0
	depends=None
	if reqnames!=None:
	    try:
		len(reqflags)
	    except:
	    	reqflags=[reqflags]
	    for reqq in reqnames:
		req=test.makeRequireString(reqq, reqversions[g], reqflags[g])
		if depends==None:
			depends=req
		else:
                	depends=depends+', '+req
		g=g+1
	    depends=correct(depends)


	provides=None
	if provides_!=None:
            for p in provides_:
        	if provides==None:
			provides=string.strip(p)
		else:
                	provides=provides+', '+string.strip(p)


	desc="<table>"
	desc=desc+"""<tr><td><b>Name:</b></td><td>"""+name+"""</td></tr>
<tr><td><b>Summary:</b></td><td>"""+summary+"""</td></tr>
<tr><td><b>Version:</b></td><td>"""+version+"""</td></tr>
<tr><td><b>Group:</b></td><td>"""+group+"""</td></tr>
<tr><td><b>Size:</b></td><td>"""+size+"""</td></tr>"""
	if unsatisfied!=None and unsatisfied!='':
		desc=desc+"<tr><td><b>Unsatisfied dependencies:</b></td><td>"+unsatisfied+"</td></tr>"
	if depends!=None:
        	desc=desc+"<tr><td><b>Depends:</b></td><td>"+depends+"</td></tr>"
	if provides!=None:
		desc=desc+"<tr><td><b>Provides:</b></td><td>"+provides+"</td></tr>"

	if distribution!=None:
		desc=desc+"<tr><td><b>Distribution:</b></td><td>"+distribution+"</td></tr>"
        if vendor!=None:
		desc=desc+"<tr><td><b>Vendor:</b></td><td>"+vendor+"</td></tr>"
        if packager!=None:
		desc=desc+"<tr><td><b>Packager:</b></td><td>"+packager+"</td></tr>"
	desc=desc+"</table>"

	return desc, files
