#!/usr/bin/env python

#*****************************************************
# RPM Wizard
# Copyright 2001-2002 Magnus Bjorklof <bjorklof@nic.fi>
# License: GNU General Public License
#*****************************************************

from conf import *
print "Installing RPM Wizard "+APPVERSION+"...\n"

import commands,sys,os,string


user=commands.getoutput('whoami')
if user=='root':
        pass
else:
        print "Sorry, you have to be root to install this program. Please change to root and try again."
        sys.exit(0)


if int(sys.version[0])<2:
	print "Wrong python version, trying to restart with python2\n"
	try: 
		os.execv('/usr/bin/env', [sys.argv[0], 'python2' ,'install.py'])
	except:
		print "Could not find python2. Install a newer version of python and try again."
		sys.exit(0)
else:
	print "Python version >= 2.0\n"


osgt=os.getenv('KDEDIR')
if osgt!=None:
	KDIR=osgt
	print commands.getoutput('mkdir --verbose -p $KDEDIR/share/rpmwiz/')
	print commands.getoutput('mkdir --verbose -p $KDEDIR/share/doc/rpmwiz-'+APPVERSION+'/')
else:
	KDIR='/usr'
	print commands.getoutput('mkdir --verbose -p /usr/share/rpmwiz/')
	print commands.getoutput('mkdir --verbose -p /usr/share/doc/rpmwiz-'+APPVERSION+'/')

def install(file, location, mdk=0):
	status, output = commands.getstatusoutput('cp '+file+' '+KDIR+location)

	if status!=0 and mdk==0:
		print "Error: Could not install", file

	elif status!=0 and mdk==1:
		pass
	else:
		print "Copying:", file

install('rpmwiz.py','/share/rpmwiz/')
install('main.py','/share/rpmwiz/')
install('det.py','/share/rpmwiz/')
install('conf.py','/share/rpmwiz/')
install('test.py','/share/rpmwiz/')

install('shortcut.py','/share/rpmwiz/')
install('pageOne.py','/share/rpmwiz/')
install('pageTwo.py','/share/rpmwiz/')
install('pageThree.py','/share/rpmwiz/')
install('image.py','/share/rpmwiz/')
install('databasereader.py','/share/rpmwiz/')
install('rpmwizdbcreator.py','/share/rpmwiz/')

install('imagerpm.png','/share/rpmwiz/')
install('rpmwiz.png','/share/rpmwiz/')




install('COPYING','/share/doc/rpmwiz-'+APPVERSION+'/')
install('README','/share/doc/rpmwiz-'+APPVERSION+'/')

#install('rpmwiz.png','/share/icons/')
install('rpmwiz.png','/share/icons/hicolor/32x32/apps/')

#install('rpmwiz_mini.png','/share/icons/mini/rpmwiz.png')
install('rpmwiz_mini.png','/share/icons/hicolor/16x16/apps/rpmwiz.png')

install('rpmwiz','/bin/')

install('rpmwiz.desktop','/share/applnk/System/')

#This should only install on a Mandrake system
install('rpmwiz.desktop','/share/applnk-mdk/Configuration/Packaging',1)

def changeToPython2(file):
	fn=open(KDIR+file, 'r+')
	fntext=fn.read()
	fn.close()
	fntext2=string.replace(fntext, '#!/usr/bin/env python\n', '#!/usr/bin/env python2\n')

	fn2=open(KDIR+file, 'w')
	fn2.write(fntext2)
	fn2.close()

status, out=commands.getstatusoutput('python2 -V')

if status==0:
	print "\nFound python2, changing files"
	changeToPython2('/bin/rpmwiz')
	changeToPython2('/share/rpmwiz/rpmwiz.py')
else:
	pass



print "\nRPM Wizard is now installed. Hope you enjoy it."
