#*****************************************************
# RPM Wizard
# Copyright 2002 Magnus Bjorklof <bjorklof@nic.fi>
# License: GNU General Public License
#*****************************************************

import os
import string
import rpm
import commands
import sys


class DBCreator:
  def listCreator(self,fileslist, Removable=0,cml=0):
    list=[]
    if cml==1:

    	total=len(fileslist)
    	amount=0
    	perclist=[]

    for file in fileslist:
	if cml==1:
		amount=amount+1

	file=string.strip(file)
	

	depends=[]
	provides=[]

	dname=[]
	dflags=[]
	dversion=[]

	try:

		fd = os.open(file, os.O_RDONLY)
        	header, isSource=rpm.headerFromPackage(fd)
		os.close(fd)

		if isSource==1:
			continue


	except:
		continue

	if header==None:
		continue


	pname=header[rpm.RPMTAG_PROVIDENAME]
	pversion=header[rpm.RPMTAG_PROVIDEVERSION]
	pflags=header[rpm.RPMTAG_PROVIDEFLAGS]

	dname=header[rpm.RPMTAG_REQUIRENAME]
	dflags=header[rpm.RPMTAG_REQUIREFLAGS]
	dversion=header[rpm.RPMTAG_REQUIREVERSION]


	

	t=0
	try:
	    for dn in dname:
		try:
			depends.append(makeRequireString(dn, dversion[t], dflags[t]))
			t=t+1
		except:
			continue
	except:
		pass
		#continue

	t=0
	try:
	    for pn in pname:
		try:
			provides.append(makeRequireString(pn, pversion[t], pflags[t]))
			t=t+1
		except:
			try:
				provides.append(makeRequireString(pn, pversion[t], pflags))
				t=t+1
			except:
				print "this is an error!!!!!!"
				continue
	except:
		pass
		#continue





	list.append((file, provides, depends))

	if cml==1:
		perc=amount*100/total
		tal=perc/5
		tal=int(tal)


	if cml==1 and (5*tal)==perc and perc!=0:
		try:
			perclist.index(perc)

		except ValueError:
			perclist.append(perc)

			print perc, '%'




    s=''

    if cml==1:
    	print "Creating list. This may take a few minutes. Please wait..."
	amount=0
	perclist=[]
	total=len(list)

    pfList=''
    depList=''
    for (filename, provides, depends) in list:
	if cml==1:
		amount=amount+1

		perc=amount*100/total
		tal=perc/5
		tal=int(tal)

	if cml==1 and (5*tal)==perc and perc!=0:
		try:
			perclist.index(perc)

		except ValueError:
			perclist.append(perc)

			print perc, '%'

	if Removable==0:
		s=s+'file:/'+filename+'\n'
	else:
		s=s+'removable:/'+filename+'\n'

	shortfilename=os.path.basename(filename) 
	for p in provides:
		pfList=pfList+p+'@'+shortfilename+'\n'

	dstring=''
	for d in depends:
		if dstring=='':
			dstring=d
		else:
			dstring=dstring+'@'+d

	depList=depList+shortfilename+'@'+dstring+'\n'


    return s,  depList,  pfList
	# Note: the lists are not python lists
	# returns (list of files, depends, provides)



def makeRequireString(reqname, reqversion, reqflags):
	require = reqname

	reqversionL=string.split(reqversion, ':')
	if len(reqversionL)==2:
		reqversion=reqversionL[1]

	if reqflags & (rpm.RPMSENSE_LESS | rpm.RPMSENSE_GREATER | rpm.RPMSENSE_EQUAL):
                    require = require+ ' '
                    if reqflags & rpm.RPMSENSE_LESS:
                        require = require + "<"
                    if reqflags & rpm.RPMSENSE_GREATER:
                        require = require + ">"
                    if reqflags & rpm.RPMSENSE_EQUAL:
                        require = require + "="
                    require = require + ' ' + reqversion
	return require
