#*****************************************************
# RPM Wizard
# Copyright 2001-2002 Magnus Bjorklof <bjorklof@nic.fi>
# License: GNU General Public License
#*****************************************************

import rpm
import fnmatch
import commands
import string, os
import pwd

from qt import *



class Shortcut:
    def files(self, header):

 	files=header[rpm.RPMTAG_FILENAMES]
	self.desktopfiles=[]

	for fil in files:
  		if fnmatch.fnmatch(fil, '*applnk*')==1 or fnmatch.fnmatch(fil, '*gnome/apps*')==1:
			if fnmatch.fnmatch(fil, '*.desktop')==1 or fnmatch.fnmatch(fil, '*.kdelnk')==1:
				self.desktopfiles.append(fil)
		else:
			pass
	# checks that there are not two files with the same name (but different path)

	for file in self.desktopfiles:
		f1=os.path.basename(file)
		n=0
		for x in self.desktopfiles:
			f2=os.path.basename(x)
			if str(f2)==str(f1):
				# finds a file the n:th time, if n==1 it has found itself
				n=n+1
				if n>1:
					self.desktopfiles.remove(x)

	return self.desktopfiles

    def copy(self):

    	tx=commands.getoutput('ls -d /home/*')
	userDirs=string.split(tx)
	userDirs.append('/root')

	for dir in userDirs:
		dir2=dir+'/Desktop/'
		dir3=dir+'/.gnome-desktop/'
		for deskfile in self.desktopfiles:
			# KDE
			status, cmx=commands.getstatusoutput('cp -v '+deskfile+' '+dir2)
			if status!=0:
				pass
			else:
				self.changeOwner(dir, dir2+os.path.basename(deskfile))

			# GNOME
			status2, cmx2=commands.getstatusoutput('cp -v '+deskfile+' '+dir3)
			if status2!=0:
				pass
			else:
				self.changeOwner(dir, dir3+os.path.basename(deskfile))


    def changeOwner(self, homepath, deskfilepath):
    	"""change the owner of the .desktop files so that they are owned by the user, not by root"""

        username=os.path.basename(homepath)
	try:
		usertup=pwd.getpwnam(username)
	except KeyError:
		print "Could not find username in database"
	uid=usertup[2]
	gid=usertup[3]
	os.chown(deskfilepath, uid, gid)

    def programName(self):
	for desktopFile in self.desktopfiles:
		f=open(desktopFile, 'r')
		l=f.readlines()

		for x in l:
			if x[:4]==('Exec' or 'exec'):
				list=string.split(x, '=')
				s=string.split(list[1])
				return s[0]
		return None

    def launchProgram(self, prog):
		path=os.environ['PATH']
		pathl=string.split(path, ':')
		pathl.append('/usr/local/bin')
		os.spawnv(os.P_NOWAIT, prog, [''])
		for p in pathl:
			os.spawnv(os.P_NOWAIT, p+'/'+prog, [''])

